function findAccel(list,spKey,accelKey){
	var	findIdx=-1
		,cnt=list.count-1;	// for add
	for(i=0;i<cnt;++i){
		if( (list.accel(i,0)===spKey) &&
			(list.accel(i,1)===accelKey)){
			findIdx=i;
			break;
		}
	}
	return findIdx;
}
function getSpKey(ev){
	var	spKey=0x0;
	if(ev.shiftKey)	spKey|=0x04;
	if(ev.ctrlKey)	spKey|=0x08;
	if(ev.altKey)	spKey|=0x10;
	return spKey;
}
function getSpKeyString(spKey){
	spKey&=~0x01;
	var	txt="";
	switch(spKey){
	case 0x04:	txt="Shift + ";					break;
	case 0x08:	txt="Ctrl + ";					break;
	case 0x0C:	txt="Ctrl + Shift + ";			break;
	case 0x10:	txt="Alt + ";					break;
	case 0x14:	txt="Shift + Alt + ";			break;
	case 0x18:	txt="Ctrl + Alt + ";			break;
	case 0x1C:	txt="Ctrl + Shift + Alt + ";	break;
	}
	return txt;
}
var	g_vkeys=[
	// event keycode, virtual:0x1, keycode, display string
	  [0x08, 0x1, 0x08, "BackSpace"]
	, [0x09, 0x1, 0x09, "Tab"]
	, [0x1B, 0x1, 0x1B, "Escape"]
	, [0x21, 0x1, 0x21, "Page Up"]
	, [0x22, 0x1, 0x22, "Page Down"]
	, [0x23, 0x1, 0x23, "End"]
	, [0x24, 0x1, 0x24, "Home"]
	, [0x25, 0x1, 0x25, "Left"]
	, [0x26, 0x1, 0x26, "Up"]
	, [0x27, 0x1, 0x27, "Right"]
	, [0x28, 0x1, 0x28, "Down"]
	, [0x29, 0x1, 0x29, "Select"]
	, [0x2A, 0x1, 0x2A, "Print"]
	, [0x2B, 0x1, 0x2B, "Execute"]
	, [0x2C, 0x1, 0x2C, "SnapShot"]
	, [0x2D, 0x1, 0x2D, "Insert"]
	, [0x2E, 0x1, 0x2E, "Delete"]
	, [0x2F, 0x1, 0x2F, "Help"]
	// Ctrl＋で動かないことがあるため取り消し
	//, [0xBA, 0x0, 0x3A, ":"]
	//, [0xBB, 0x0, 0x3B, ";"]
	//, [0xBC, 0x0, 0x2C, ","]
	//, [0xBD, 0x0, 0x2D, "-"]
	//, [0xBE, 0x0, 0x2E, "."]
	//, [0xBF, 0x0, 0x2F, "/"]
	//, [0xC0, 0x0, 0x40, "@"]
	//, [0xDB, 0x0, 0x5B, "["]
	//, [0xDC, 0x0, 0x5C, "\\"]
	//, [0xDD, 0x0, 0x7D, "]"]
	//, [0xDE, 0x0, 0x5E, "^"]
	//, [0xE2, 0x0, 0x5C, "\\"]
	//, [0x6F, 0x0, 0x2F, "/"]
	//, [0x6E, 0x0, 0x2E, "."]
	//, [0x6D, 0x0, 0x2D, "-"]
	//, [0x6B, 0x0, 0x2B, "+"]
	//, [0x6A, 0x0, 0x2A, "*"]
];
function findVKey(keyCode){
	var	vkeyLen=g_vkeys.length;
	for(vkey_i=0;vkey_i<vkeyLen;++vkey_i){
		if(g_vkeys[vkey_i][0]===keyCode){
			return vkey_i;
		}
	}
	return -1;
}
function compareAccelList(left,right){
	var	leftCnt=left.count,rightCnt=right.count
		,isEqual=(leftCnt===rightCnt);
	if(isEqual){
		for(i=0;i<leftCnt;++i){
			if((left.accel(i,0)!==right.accel(i,0))||
			   (left.accel(i,1)!==right.accel(i,1))||
			   (left.accel(i,2)!==right.accel(i,2))){
				isEqual=false;
				break;
			}
		}
	}
	return isEqual;
}
function accelKeyToEventKeyCode(accelKey,isVirt){
	var	vkeyLen=g_vkeys.length;
	for(vkey_i=0;vkey_i<vkeyLen;++vkey_i){
		if(g_vkeys[vkey_i][2]===accelKey&&g_vkeys[vkey_i][1]===isVirt){
			return g_vkeys[vkey_i][0];
		}
	}
	return accelKey;
}
function eventToAccelInfo(ev){
	var	keyCode=ev.keyCode,spKey=getSpKey(ev),spTxt="",keyTxt="";

	// ctrl,shift,alt
	if(0x10==keyCode||0x11==keyCode||0x12==keyCode){
		keyInfo=$(ev.target).data("keyInfo");
		if(undefined!==keyInfo){
			keyTxt=keyInfo.keyTxt;
			keyCode=keyInfo.keyCode;
		}
		spKey+=0x1;
	}else
	// alnum
	if((0x30<=keyCode)&&(keyCode<=0x39)||
	   (0x41<=keyCode)&&(keyCode<=0x5A)){
		// must Ctrl
		if(0===spKey){
			spKey=0x8;
		}
		spKey+=0x1;
		keyTxt=String.fromCharCode(keyCode);
	}else
	// F1 ... F24
	if((0x70<=keyCode)&&(keyCode<=0x87)){
		keyTxt="F"+(keyCode-0x6F).toString();
		spKey+=0x1;
	}else
	// numpad
	if((0x60<=keyCode)&&(keyCode<=0x69)){
		// must ctrl
		if(0===spKey){
			spKey=0x8;
		}
		spKey+=0x1;
		keyTxt=(keyCode-0x60).toString();
	}else{
		// virtual key
		var	vkey_i=findVKey(keyCode);
		if(-1!==vkey_i){
			spKey+=g_vkeys[vkey_i][1];
			keyCode=g_vkeys[vkey_i][2];
			keyTxt=g_vkeys[vkey_i][3];
		}else{
			// debug
			if(false){
				keyTxt+=keyCode.toString();
				keyTxt+="(0x";
				keyTxt+=keyCode.toString(16);
				keyTxt+=")";
				keyTxt+=" "+String.fromCharCode(keyCode);
			}
		}
	}

	var	accel=null;
	if(keyTxt&&keyTxt.length){
		// save accel key for press only ctrl,shift,alt
		$(ev.target).data("keyInfo",{keyTxt:keyTxt,keyCode:keyCode});
		accel={virt:spKey,key:keyCode,text:getSpKeyString(spKey)+keyTxt};
	}
	return accel;
}
function inputAccel(ev){
	var	keyCode=ev.keyCode,accelKey=keyCode,spKey=getSpKey(ev);

	// tab, numlock
	if((0x00===spKey&&0x9===keyCode)||(0x90===keyCode)){
		return true;
	}

	// return
	if(0x0D===keyCode){
		optionApply();
		return false;
	}

	var	info=eventToAccelInfo(ev);
	if(!info){
		return false;
	}
	
	var	input=$(ev.target)
		,accel=input.data("accel")
		,list=accel.list
		,isAdd=(accel.index==null)
		,index=(isAdd?list.count-1:accel.index)
		,sameIndex=findAccel(list,info.virt,info.key)
		,isFind=(-1!==sameIndex&&index!=sameIndex);

	input.val(info.text);
	list.accel(index,0)=info.virt;
	list.accel(index,1)=info.key;
	input.toggleClass("cAccelNg",isFind);
	input.addClass("cMod",!isFind);
	if(isAdd){
		var	contentId=input.attr("contentId")
			,addBtn=$("#"+contentId+"Add")
			,ng=$("#"+contentId+"Ng");
		addBtn.attr("disabled",isFind);
		if(isFind){
			ng.show();
		}else{
			ng.hide();
		}
	}
	return false;
}
function changeAccelCmd(elem){
	var	accel=$.data(elem,"accel")
		,list=accel.list
		,idx=(accel.index!=null?accel.index:list.count-1);
	list.accel(idx,2)=elem.value;
}
function addAccel(btn){
	var	contentId=$(btn).attr("contentId")
		,formCmd=document.forms[contentId+"Cmd"]
		,content=$("#"+contentId)
		,accel=content.data("accel");
	refreshAccel(contentId,accel.list,true);
	btn.disabled=true;
	var	formInput=document.forms[contentId+"Input"];
	formInput.v.value="";
	formInput.v.focus();
	selectOption(formCmd.v.options,"none");
}
function delAccel(btn,accel,isDel){
	var	div=$("#"+accel.contentId+accel.index);
	$(":input:not(button)",div).attr("disabled",isDel);
	accel.list.markDel(accel.index)=isDel;
	$(":first",btn).text(isDel?"取消":"削除");
	$(btn).toggleClass("cAccelDel cAccelDelCancel");
}
$("button.cAccelAdd:enabled").live("click", function(ev){
	addAccel(ev.target);
});
$("button.cAccelDel,button.cAccelDelCancel").live("click",function(ev){
	var	isDel=(-1===ev.target.className.indexOf("cAccelDelCancel"))
		,accel=$.data(ev.target,"accel");
	delAccel(ev.target,accel,isDel);
});
$("input.cAccelInput").live("keydown",function(ev){
	return inputAccel(ev);
});
$("input.cAccelInput").live("focus blur",function(ev){
	var	isPrevent=("focusin"===ev.type);
	g_ext.preventTransAccel(isPrevent);
	return true;
});
$("form[name=idAppAccelInput]").live("focus blur",function(ev){
	toggleCueBanner(ev,g_cueBannerTxt[ev.target.form.name]);
});
/*  change が動かない
$("select.cAccelCmdHidden").live("change",function(ev){
	changeAccelCmd(ev.target);
	return false;
});
*/
function refreshAccel(contentId,list,isAdd){
	var	content=$$(contentId);
	var	cnt=list.count,parent=$(content)
		,headData={contentId:contentId,list:list};
	parent.data("accel",headData);
	if(! isAdd){
		parent.empty();
		var	head=$("[name="+contentId+"Input] [name=v],[name="+contentId+"Cmd] [name=v]");
		head.data("accel",headData);
	}else{
		// remove "empty" content
		if(3==content.firstChild.nodeType){
			parent.empty();
		}
	}
	if(cnt){
		var	ev=document.createEventObject()
			,textInputBase=$("<input type=text name=v class=cAccelInput>")
			,selectCmdBase=$("<select name=v class=cSelectCmd>")
			,btnDelBase=$("<button>")
			,c=document.createElement;
		//btnDelBase.css("width","8em");
		btnDelBase.append($("<span>削除</span>")).addClass("cAccelDel");
		for(i=cnt-1;i>=0;--i){
			var	virt=list.accel(i,0)
				,key=list.accel(i,1)
				,cmd=list.accel(i,2)
				,accel={contentId:contentId,list:list,index:i}
				,div=$("<div>").text(": ").attr("id",contentId+i)
				,formInput=$(c("<form name="+contentId+"Input"+i+">"))
				,textInput=textInputBase.clone();
			textInput.data("accel",accel);
			if(isAdd){
				div.addClass("cAdd cHide");
				textInput.addClass("cMod");
			}
			var	formCmd=$(c("<form name="+contentId+"Cmd"+i+" class=cDummy>"));
			var selectCmd=selectCmdBase.clone();
			selectCmd.data("accel",accel);
			selectCmd.change(function(ev){changeAccelCmd(ev.target)});
			var	btnDel=btnDelBase.clone().data("accel",accel);
			
			ev.shiftKey=(virt&0x4?true:false);
			ev.ctrlKey=(virt&0x8?true:false);
			ev.altKey=(virt&0x10?true:false);
			ev.keyCode=accelKeyToEventKeyCode(key,(virt&0x1));
			ev.target=textInput.get(0);
			var	info=eventToAccelInfo(ev);
			if(info){
				textInput.val(info.text);
			}
			
			var	optCmd=selectCmd.get(0).options;
			optCmd.length=1;
			optCmd[0].value=cmd;
			optCmd[0].text=getCmdDisplayName(cmd);
			
			div .append(formInput.append(textInput))
				.append(formCmd.append(selectCmd))
				.append(btnDel);
			
			if(isAdd&&parent.get(0).firstChild){
				$(parent.get(0).firstChild).before(div);
			}else{
				parent.append(div);
			}
			if(isAdd){
				div.slideDown("n");
				break;
			}
		}
	}else{
		parent.text("なし");
	}
	// for accel add
	list.add(0,0,"none");
}
function setDefaultAccel(){
	refreshAccel("idAppAccel",g_setting.defaultAccelList,false);
}
(function(){refreshAccel("idAppAccel",g_setting.accelList,false);})();